//var gABGoogleContactsSyncDone = false;

var GCSabDirTreeObserverOnDropOrg = abDirTreeObserver.onDrop;
abDirTreeObserver.onDrop = function(row, orientation) {
		GCSabDirTreeObserverOnDropOrg.apply(this, arguments);
		var dragService = Components.classes["@mozilla.org/widget/dragservice;1"].getService().
											QueryInterface(Components.interfaces.nsIDragService);
    var dragSession = dragService.getCurrentSession();
    if (!dragSession) {
      return;
    }
		//var dirTree = document.getElementById('dirTree');
		//if (!dirTree) return;
		
    var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
    trans.addDataFlavor("moz/abcard");

    //var targetResource = dirTree.builderView.getResourceAtIndex(row);

    //var targetURI = targetResource.Value;
    //var directory = GetDirectoryFromURI(targetURI);
    var directory = gDirectoryTreeView.getDirectoryAtIndex(row);
   	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.onItemPropertyChanged(directory, null, null, null);
}

var gGCContactManagerAB = {
	progressStart: function() {
		var meter = document.getElementById("gmcont-progresspanel");
		meter.removeAttribute("collapsed");
		var meterIcon = document.getElementById("gmcont-progress");
		meterIcon.setAttribute("mode", "undetermined");
	},
	
	progressEnd: function() {
		var meter = document.getElementById("gmcont-progresspanel");
		meter.setAttribute("collapsed",true);
		var meterIcon = document.getElementById("gmcont-progress");
		meterIcon.setAttribute("mode", "normal");
	},
	
	doGCABCommand: function(event) {
		var cmd = event.target.getAttribute("value");
		switch (cmd) {
			case "reload":
				this.reloadGoogleContacts();
				break;
			case "undo":
				this.undoGoogleContacts(
														event.target.getAttribute("account"),
														event.target.getAttribute("index")
														);
				break;
			case "dup":
				this.removeDuplicates(
														event.target.getAttribute("label")
														);
				break;
			case "photo":
				this.reloadGoogleContactsPhotos();
				break;
			case "photoup":
				var cards = GetSelectedAbCards();
				var selectedDirURI = GetSelectedDirectory();
				var parentURI = GetParentDirectoryFromMailingListURI(selectedDirURI);
				if (parentURI) selectedDirURI = parentURI; //for mail list
				this.uploadGoogleContactsPhotos(cards, selectedDirURI);
				break;
			case "photodel":
				var cards = GetSelectedAbCards();
				var selectedDirURI = GetSelectedDirectory();
				var parentURI = GetParentDirectoryFromMailingListURI(selectedDirURI);
				if (parentURI) selectedDirURI = parentURI; //for mail list
				this.deleteGoogleContactsPhotos(cards, selectedDirURI);
				break;
			default:
				break;
		}
	},
	
	reloadGoogleContacts: function() {
		SelectFirstAddressBook();
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.startSync(false);
		//setTimeout(UpdateCardView, 0);
		//setTimeout(LoadPreviouslySelectedAB, 0);
	},

	reloadGoogleContactsPhotos: function() {
		SelectFirstAddressBook();
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.reloadPhotos();
		//setTimeout(UpdateCardView, 0);
		//setTimeout(LoadPreviouslySelectedAB, 0);
	},
	
	uploadGoogleContactsPhotos: function(cards, abURI) {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.uploadPhotos(cards, abURI);
	},
	
	deleteGoogleContactsPhotos: function(cards, abURI) {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.deletePhotos(cards, abURI);
	},
	
	undoGoogleContacts: function(account, index) {
		SelectFirstAddressBook();
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.undoDeletedEntry(account, index);
	},
	
	undoAccountShowing: function(target) {
		if (target.getAttribute("id") != "GCUndoAccountPopup") return;
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (!messenger) return;
		
		var localeBundle = document.getElementById("GmContBundle");
		
		//clear popup first
		var popup = document.getElementById("GCUndoAccountPopup");
		var childMenus = popup.childNodes;
		var menuNum = childMenus.length;
		for (var i=menuNum-1; i>=0; i--) {
			var node = childMenus[i];
			if (node) popup.removeChild(node);
		}
		
		//build popup
		var entries = messenger.gGCContactManager.getDeletedEntries();
		var key;
		for (key in entries) {
			var accountData = entries[key];
			var accountMenu = document.createElement("menu");
			accountMenu.setAttribute("class", "menu-iconic");
			accountMenu.setAttribute("type", "gcaccount");
			var accountPopup = document.createElement("menupopup");
			accountMenu.setAttribute("label", key);
			accountMenu.setAttribute("tooltiptext", key);
			for (var i=0; i<accountData.length; i++) {
				var entry = accountData[i];
				var menuitem = document.createElement("menuitem");
				menuitem.setAttribute("label", entry.label);
				menuitem.setAttribute("tooltiptext", entry.label);
				menuitem.setAttribute("type", entry.type);
				menuitem.setAttribute("index", entry.index);
				menuitem.setAttribute("value", "undo");
				menuitem.setAttribute("account", key);
				menuitem.setAttribute("class", "menuitem-iconic");
				accountPopup.appendChild(menuitem);
			}
			
			if (accountData.length == 0) {
				var label = localeBundle.getString("gmcont.undo_no_entry");
				var menuitem = document.createElement("menuitem");
				menuitem.setAttribute("label", label);
				menuitem.setAttribute("tooltiptext", label);
				menuitem.setAttribute("disabled", true);
				accountPopup.appendChild(menuitem);
			} else { 
				var sep = document.createElement("menuseparator");
				accountPopup.appendChild(sep);
				var label = localeBundle.getString("gmcont.undo_all");
				var menuitem = document.createElement("menuitem");
				menuitem.setAttribute("label", label);
				menuitem.setAttribute("tooltiptext", label);
				menuitem.setAttribute("type", "all");
				menuitem.setAttribute("index", "-1");
				menuitem.setAttribute("value", "undo");
				menuitem.setAttribute("account", key);
				menuitem.setAttribute("class", "menuitem-iconic");
				accountPopup.appendChild(menuitem);
			}
			
			accountMenu.appendChild(accountPopup);
			popup.appendChild(accountMenu);
		}
	},
	
	remDupsAccountSowing: function(target) {
		if (target.getAttribute("id") != "GCRemDups") return;
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (!messenger) return;
		
		//clear popup first
		var childMenus = target.childNodes;
		var menuNum = childMenus.length;
		for (var i=menuNum-1; i>=0; i--) {
			var node = childMenus[i];
			if (node) target.removeChild(node);
		}
		
		//build popup
		var accounts = messenger.gGCContactManager.getAccounts(); 
		for (var i=0; i<accounts.length; i++) {
			var account = accounts[i];
			var accountMenu = document.createElement("menuitem");
			accountMenu.setAttribute("label", account);
			accountMenu.setAttribute("tooltiptext", account);
			accountMenu.setAttribute("value", "dup");
			target.appendChild(accountMenu);
		}
	},
	
	removeDuplicates: function(account) {
		SelectFirstAddressBook();
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.removeDuplicates(account);
	}
};