var gGCSetting;

function initGCSetting()
{
  var observerService = Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces.nsIObserverService);
  observerService.notifyObservers(null, 'charsetmenu-selected', 'other');
	gGCSetting = new GCSetting();
	gGCSetting.onLoad();
}

function GCSetting()
{
	this.elementIDs = [
		//"GCMaxResults",
		"GCAuthAtStartup",
		"GCConfBatchDel",
		"GCSyncMode",
		"GCYieldWeight",
		"GCAlwaysReloadPhotos",
		//"GCNameConv",
		//"GCAddrConvFormat",
		//"GCAddrConvDelimiter",
		"GCAddPseudoEmail",
		"GCMaxBackups",
		//"GCBackupPath",
		//"GCBackupCharsetTB",
		//"GCBackupCharsetGC",
		"GCUseDiskCache",
		"GCRemoveDiskCache",
		"GCAutoReloadIntervalValue",
		"GCAutoReloadOnline",
		"GCMapDelMode",
		"GCReloadParallel",
		"GCFastSyncPhoto",
		//"GCUseHTTPMethodOverride",
		"GCMaxResultsInPage",
		"GCDumpRawXML",
		//"GCSuppressMailListCheck",
		"GCIgnoreXMLParseError",
		"GCAddToMyContacts",
		"GCAddress2Use",
		"GCMainPhoneMap",
		"GCFaxAttribute",
		"GCUseContactEtag",
		"GCTakeLog",
		"GCDupCheck"
		];
	this.accountElemIDs = new Array();
	this.accountNum = 0;
	this.pref = Components.classes["@mozilla.org/preferences-service;1"]
	  .getService(Components.interfaces.nsIPrefBranch);
	this.syncGroupListItemSkel = document.getElementById("dummy_row");
}

GCSetting.prototype.savePrefs = function()
{
	for( var i = 0; i < this.elementIDs.length; i++ ) {
		var elementID = this.elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;
		if (eltType == "radiogroup")
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
		else if (eltType == "checkbox")
		  this.pref.setBoolPref(element.getAttribute("prefstring"), element.checked);
		else if (eltType == "listitem" && element.getAttribute("type") == "checkbox")
		  this.pref.setBoolPref(element.getAttribute("prefstring"), element.checked);
 		else if (eltType == "listitem" && element.getAttribute("preftype") == "string")
			nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.getAttribute("value"));
		else if (eltType == "listbox")
			nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.getAttribute("prefvalue"));
		else if (eltType == "textbox" && element.getAttribute("preftype") == "int") {
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value) );
		} else if (eltType == "textbox")
		  nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.value);
	  else if (eltType == "menulist" && element.getAttribute("preftype") == "string")
		  this.pref.setCharPref(element.getAttribute("prefstring"), element.value);
		else if (eltType == "menulist")
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
		else if (eltType == "scale")
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
  
	}
	
	this.saveBackupDir(document.getElementById("GCBackupPath"));
	return true;
}

GCSetting.prototype.cancelPrefs = function()
{
	return true;
}

GCSetting.prototype.onLoad = function()
{
	// initialize the default window values...
	for( var i = 0; i < this.elementIDs.length; i++ ) {
		var elementID = this.elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;

		if (eltType == "radiogroup") {
			try {
				element.selectedItem = element.childNodes[this.pref.getIntPref(element.getAttribute("prefstring"))];
			} catch(e) {
				element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
				try {
					this.pref.setIntPref( element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
				} catch (e) {}
			}
		} else if (eltType == "checkbox") {
			try {
				element.checked = ( this.pref.getBoolPref(element.getAttribute("prefstring")) == true );
			} catch(e) {
				element.checked = ( element.getAttribute("defaultpref") == "true" );
				try {
					this.pref.setBoolPref( element.getAttribute("prefstring"), element.checked );
				} catch(e){}
			}
		} else if (eltType == "textbox" && element.getAttribute("preftype") == "int") {
			var val = nsPreferences.getIntPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref"));
			element.setAttribute("value", val);
		} else if (eltType == "textbox") {
			var str = nsPreferences.copyUnicharPref(element.getAttribute("prefstring"),"");
			if (str) element.setAttribute("value", str);
		} else if (eltType == "menulist" && element.getAttribute("preftype") == "string") {
			var str = nsPreferences.copyUnicharPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref"));
			//if (str) element.setAttribute("value", str);		
			if (str) element.value = str;		
		} else if (eltType == "menulist") {
			try {
				element.value = this.pref.getIntPref(element.getAttribute("prefstring")).toString();
			} catch(e) {
				element.value = element.getAttribute("defaultpref");
				try {
					this.pref.setIntPref( element.getAttribute("prefstring"), parseInt(element.value) );
				} catch (e) {}
			}
		} else if (eltType == "scale") {
			var val = nsPreferences.getIntPref(element.getAttribute("prefstring"), parseInt(element.getAttribute("defaultpref")));
			var minVal = parseInt(element.getAttribute("min"));
			var maxVal = parseInt(element.getAttribute("max"));
			if (val < minVal) val = minVal;
			else if (val > maxVal) val = maxVal;
			element.setAttribute("value", val);
		}
	}
	
	// set up account list
	this.initAccountList();
	//this.initCharsetList();
	this.onToggleAutoReloadInterval();
	this.setBackupDir(document.getElementById("GCBackupPath"));
	this.initSyncGroupTable();
	if (window.arguments && window.arguments[0]) {
		var highlightElems = window.arguments[0].split(",");
		for (var i=0; i<highlightElems.length; i++) {
			var elem = document.getElementById(highlightElems[i]).setAttribute("highlighted", "true");
		}
	}
}

GCSetting.prototype.initAccountList = function()
{
	var listbox = document.getElementById("GCAccountListBox");
	var userInfo = gGCAccountManager.getGmailSignons([]);
	var user = "";
	for (user in userInfo) {
		this.appendAccountToList(listbox, user, false);
	}
	
	userInfo = gGCAccountManager.getCustomSignons([]);
	for (user in userInfo) {
		this.appendAccountToList(listbox, user, true);
	}
	
	listbox.selectedIndex = 0;
}

GCSetting.prototype.updateDeleteButtonStatus = function(listitem)
{
	var button = document.getElementById("GCDelAcctButton");
	if (!listitem || !listitem.getAttribute("custom")) button.setAttribute("disabled", true);
	else button.removeAttribute("disabled");
}

GCSetting.prototype.appendAccountToList = function(listbox, user, isCustom)
{
	var prefStr = "gmcont."+user+".sync";
	var checked = nsPreferences.getBoolPref(prefStr, true);
	var sync_cell = document.createElement("listcell");
	var sync_ena = document.createElement("checkbox");
	sync_ena.setAttribute("checked", checked);
	sync_ena.setAttribute("prefstring", prefStr);
	sync_ena.setAttribute("defaultpref", true);
	sync_ena.setAttribute("id", "GCAccount"+user);
	sync_cell.setAttribute("align","right");
	sync_cell.appendChild(sync_ena);
	
	var acc_cell = document.createElement("listcell");
	var acc = document.createElement("label");
	acc.setAttribute("value", user);
	acc.setAttribute("id", "GCAccount"+user+"_label");
	acc_cell.appendChild(acc);

	var listitem = document.createElement("listitem");
	listitem.appendChild(sync_cell);
	listitem.appendChild(acc_cell);
	if (isCustom) listitem.setAttribute("custom", true);
	listitem.setAttribute("allowevents", "true");

	listbox.appendChild(listitem);
	
	this.elementIDs.push("GCAccount"+user);
	this.accountElemIDs.push("GCAccount"+user);
	
	if (document.getElementById("dummy")) listbox.removeItemAt(0);
}

GCSetting.prototype.addCustomAccount = function()
{
	var callback = { account: "" };
	window.openDialog("chrome://gmcont/content/addAccountDialog.xul", "gmcont-custaccount", "chrome,modal,dialog,centerscreen", callback);
	if (callback.account == "") return;
	if (callback.account.indexOf("@") == -1) {
		var msg = document.getElementById("localeBundle").getString("gmcont_set.invalid_account");
		alert(msg);
		return;
	}
	
	var customAccounts = nsPreferences.copyUnicharPref("gmcont.custom_accounts", null);
	if (customAccounts) customAccounts += ","+callback.account;
	else customAccounts = callback.account;
	nsPreferences.setUnicharPref("gmcont.custom_accounts", customAccounts);
	var listbox = document.getElementById("GCAccountListBox");
	this.appendAccountToList(listbox, callback.account, true);
	this.initSyncGroupTable();
}

GCSetting.prototype.deleteCustomAccount = function()
{
	var listbox = document.getElementById("GCAccountListBox");
	var account = listbox.selectedItem.getElementsByTagName("label")[0].getAttribute("value");
	this.clearUserPref("gmcont."+account+".aburi");
	this.clearUserPref("gmcont."+account+".sync");
	var customAccounts = nsPreferences.copyUnicharPref("gmcont.custom_accounts", null);
	if (customAccounts) {
		var accounts = customAccounts.split(",");
		var i = accounts.indexOf(account);
		if (i != -1) {
			accounts.splice(i,1);
			customAccounts = accounts.join(",");
			nsPreferences.setUnicharPref("gmcont.custom_accounts", customAccounts);
		}
	}
	var index = listbox.selectedIndex;
	var removedItem = listbox.removeItemAt(index);
	var removedItemId = removedItem.getElementsByTagName("checkbox")[0].getAttribute("id");
	var removedItemIdIndex = this.accountElemIDs.indexOf(removedItemId);
	this.accountElemIDs.splice(removedItemIdIndex, 1);
	if (listbox.getRowCount() == 0) {
		var dummyItem = listbox.appendItem(""); // add dummy
		dummyItem.setAttribute("id", "dummy");
		index = 0;
	}
	if (index >= listbox.getRowCount()) listbox.selectedIndex = listbox.getRowCount() - 1;

	listbox.selectedIndex = index;
	this.initSyncGroupTable();
}

GCSetting.prototype.clearUserPref = function(prefstr)
{
	try {
		this.pref.clearUserPref(prefstr);
	} catch(e) {
	}
}

GCSetting.prototype.checkAllAccount = function(checked)
{
	var listbox = document.getElementById("GCAccountListBox");
	var rows = listbox.getRowCount();
	for (var i=0; i<rows; i++) {
		 var listitem = listbox.getItemAtIndex(i);
		 if (checked) listitem.getElementsByTagName("checkbox")[0].setAttribute("checked", true);
		 else listitem.getElementsByTagName("checkbox")[0].setAttribute("checked", false);
	}
}

GCSetting.prototype.verifyTextBoxForNum = function(target, isFloat, minVal)
{
	var num = isFloat ? parseFloat(target.value) : parseInt(target.value);
	var defNum = target.getAttribute("value");
	var minValue = minVal ? minVal : 0;
	if (isNaN(num) || num < minValue) {
		target.value = defNum;
	} else {
		target.value = num.toString();
		target.setAttribute("value", target.value);
	}
}

GCSetting.prototype.showBackupDir = function(elem)
{
	if (!elem) return;
	var absPath = elem.value;
	var file = null;
	try {
  	file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  	file.initWithPath(absPath);
	} catch(e) {
		file = null
	}
	
	if (!file) {
		file = Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties)
								.get("ProfD", Components.interfaces.nsILocalFile);
		file.append("GoogleContacts");
	}
	
	if (!file.exists())
  	file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
 	file.reveal();

  return;
}

GCSetting.prototype.saveBackupDir = function(elem)
{
	if (!elem) return;
	var absPath = elem.value;
	var file = null;
	try {
  	file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  	file.initWithPath(absPath);
	} catch(e) {
		file = null
	}
	
	try {
		if (!file) {
			file = Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties)
								.get("ProfD", Components.interfaces.nsILocalFile);
			file.append("GoogleContacts");
		}
		
	  var relFile = Components.classes["@mozilla.org/pref-relativefile;1"]
	                        .createInstance(Components.interfaces.nsIRelativeFilePref);
		relFile.relativeToKey = "ProfD"; //start point
		relFile.file = file;
		var prefstring = elem.getAttribute("prefstring");
		this.pref.setComplexValue(prefstring, Components.interfaces.nsIRelativeFilePref, relFile);
	} catch(e) {
		gGCLogger.dump("Error: Cannot save dump dir.\n")
	}
}

GCSetting.prototype.setBackupDir = function(elem)
{
	//if (elem.value) return;
	if (!elem) return;
	var file = null;
	try {
		var prefstring = elem.getAttribute("prefstring");
		var value = this.pref.getComplexValue(prefstring, Components.interfaces.nsIRelativeFilePref);
		file = value.file;
		if (!file || !file.isWritable() || !file.isReadable()) file = null;
	} catch(e) {
		file = null;
	}
	
	if (!file) {
		file = Components.classes["@mozilla.org/file/directory_service;1"]
							.getService(Components.interfaces.nsIProperties)
							.get("ProfD", Components.interfaces.nsILocalFile);
		file.append("GoogleContacts");
	}
	
	try {
		if (!file.exists()) {
  		file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
		}
		elem.setAttribute("value", file.path);
	} catch(e) {
		gGCLogger.dump("Error: Cannot create dump dir.\n")
	}
  	// elem.setAttribute("value", file.nativePath);
}

GCSetting.prototype.browseForBackupDir = function(dispElem)
{
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
  var currentFolder = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  currentFolder.initWithPath(dispElem.value);
	var title = document.getElementById("localeBundle").getString("gmcont_set.browse_backdir_title");
  fp.init(window, title, Components.interfaces.nsIFilePicker.modeGetFolder);

  fp.displayDirectory = currentFolder;

  var ret = fp.show();

  if (ret == Components.interfaces.nsIFilePicker.returnOK) {
		var file = fp.file;
  	if (!file || !file.isWritable() || !file.isReadable()) {
  		alert("Invalid file path or no access permission.")
  	} else {
  		//dispElem.value = fp.file.path;
  		dispElem.value = file.path;
  	}
  }
}

GCSetting.prototype.onToggleAutoReloadInterval = function(aEvent)
{
	var elem = document.getElementById("GCAutoReloadInterval");
	var textbox = document.getElementById("GCAutoReloadIntervalValue");
	var enable = false;
	this.verifyTextBoxForNum(textbox, true);
	
	if (aEvent) {
		enable = elem.checked;
	} else {
		enable = (!isNaN(parseFloat(textbox.value)) &&  parseFloat(textbox.value) > 0);		
	}
	
	if (enable) {
		textbox.removeAttribute("disabled");
		elem.setAttribute("checked", true);
	} else {
		textbox.setAttribute("disabled", true);
		elem.removeAttribute("checked");
		textbox.value = "";
	}	
}

GCSetting.prototype.initSyncGroupTable = function()
{
	var table = document.getElementById("GCSyncGroupTable");
	var rowCount = table.getRowCount();
	for (var i=rowCount-1; i>=0; i--) {
		table.removeItemAt(i);
	}

	if (this.accountElemIDs.length > 0) {
		for (var i=0; i<this.accountElemIDs.length; i++) {
			var accountElem = document.getElementById(this.accountElemIDs[i]+"_label");
			if (!accountElem) break;
			var label = accountElem.value ? accountElem.value : accountElem.getAttribute("value"); // unconfirm but label may be undefined
			var row = this.createAccountGroupRow(label, this.syncGroupListItemSkel, table);
			//table.appendChild(row);
		}
	} else {
		table.appendChild(this.syncGroupListItemSkel);
	}
}

GCSetting.prototype.createAccountGroupRow = function(account, skel, table)
{
	// var skel = document.getElementById("dummy_row");
	var newRow = skel.cloneNode(true);
	newRow.setAttribute("id","row_" + account);
	this.elementIDs.push("row_" + account);
	newRow.removeAttribute("hidden");
	table.appendChild(newRow);
	var newCell = newRow.firstChild;
	newCell.setAttribute("id","cell_" + account);
	newCell.setAttribute("label", account);
	newCell.setAttribute("tooltiptext", account);
	newRow.setAttribute("prefstring", "gmcont."+account+".sync_group");
	newRow.setAttribute("defaultpref", "");
	newRow.setAttribute("preftype", "string");
	
	var prefvalue = nsPreferences.copyUnicharPref("gmcont."+account+".sync_group", "");
	// var listcell = newRow.lastChild;
	// var menulist = listcell.firstChild;
	//var menulists = newRow.getElementsByAttribute("id", "pop_list");
	var menulists = newRow.getElementsByTagName("menulist");
	var menulist = menulists[0];
	menulist.removeAttribute("disabled");
	
	var isGoogleApps = !(account.match(/@(gmail\.com|googlemail\.com)$/i));
	if (isGoogleApps) {
		//(newRow.getElementsByAttribute("id", "map_contacts"))[0].setAttribute("collapsed", true);
		(newRow.getElementsByAttribute("id", "map_friends"))[0].setAttribute("collapsed", true);
		(newRow.getElementsByAttribute("id", "map_family"))[0].setAttribute("collapsed", true);
		(newRow.getElementsByAttribute("id", "map_coworkers"))[0].setAttribute("collapsed", true);
		//(newRow.getElementsByAttribute("id", "map_sep"))[0].setAttribute("collapsed", true);
	}
	
	switch (prefvalue) {
		case "Contacts": case "Friends":
		case "Family":   case "Coworkers":
		case "":
			menulist.value = prefvalue;
			break;
		default:
			menulist.insertItemAt(0, prefvalue, prefvalue);
			menulist.value = prefvalue;
			break;
	}
	this.syncGroupChanged(menulist);
	
	return newRow;
}

GCSetting.prototype.syncGroupChanged = function(menulist)
{
	var listcell = menulist.parentNode;
	var listitem = listcell.parentNode;

	var val = menulist.getAttribute("value");
	listitem.setAttribute("value",val);
}

GCSetting.prototype.addSyncGroup = function(menuitem)
{
	var menupopup = menuitem.parentNode;
	var menuitems = menupopup.childNodes;
	var menulist = menupopup.parentNode;
	
	var callback = { group: "" };
	window.openDialog("chrome://gmcont/content/addGroupDialog.xul", "gmcont-custaccount", "chrome,modal,dialog,centerscreen", callback);

	if (callback.group == "") {
		menulist.selectedIndex = 0;
		return;
	}

	for (var i=0; i<menuitems.length; i++) {
		var item = menuitems[i];
		if (item.getAttribute("value") == callback.group) return;
	}

	var menulist = menupopup.parentNode;
	menulist.insertItemAt(0, callback.group, callback.group);
	menulist.value = callback.group;

	this.syncGroupChanged(menulist);
	
	return;
}

GCSetting.prototype.openLogFile = function()
{
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
				getService(Components.interfaces.nsIWindowMediator);
	var messenger = windowMediator.getMostRecentWindow("mail:3pane");
	if (messenger) messenger.gGCLogger.flush();
	var addressbook = windowMediator.getMostRecentWindow("mail:addressbook");
	if (addressbook) addressbook.gGCLogger.flush();
	gGCLogger.flush();
	
	var URI = Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService).newFileURI(gGCLogger.logFile);
	var fileURI = URI.QueryInterface(Components.interfaces.nsIFileURL).asciiSpec;
	window.openDialog("chrome://global/content/viewSource.xul",
							"_blank", "all,dialog=no", fileURI,
							"charset=UTF-8");
}